unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, StrUtils, Math, jpeg, ExtDlgs,
  XPMan, IniFiles;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button2: TButton;
    Button10: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button21: TButton;
    Button22: TButton;
    Button23: TButton;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    Button4: TButton;
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    TrackBar3: TTrackBar;
    TrackBar7: TTrackBar;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Image2: TImage;
    FontDialog1: TFontDialog;
    Button3: TButton;
    Button5: TButton;
    Button6: TButton;
    Timer1: TTimer;
    Button7: TButton;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure Button22Click(Sender: TObject);
    procedure Button23Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button7Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Light : INTEGER;
  Once : boolean = true; // for BootLogo
  LCD_Width : integer = 130;
  LCD_Height : integer = 130;
  LCD_Port : integer = $378;
  LCD_ExectimeGfx : integer = 0;
  ContrastValue : byte;
  Contrast_ON : boolean;
  Form1: TForm1;
  f2,f3,f4:integer;
  f1,f5:string;
  xxx,yyy:integer;
  xer:integer;
    function DlPortReadPortUchar(Port:longint):byte;stdcall;external 'DLPORTIO.DLL';
    procedure DlPortWritePortUchar(Port:longint;Value:byte);stdcall;external 'DLPORTIO.DLL';
implementation

{$R *.dfm}

procedure Command (Value: Byte);
var i : Byte;
begin
DlPortWritePortUchar($378 , 255-1);

For i := 7 downto 0 do
if (Value And (1 shl i))>0 then
  begin
   DlPortWritePortUchar($37A , 2) ;
   DlPortWritePortUchar($37A , 0) ;
  end
else
  begin
   DlPortWritePortUchar($37A , 3) ;
   DlPortWritePortUchar($37A , 1) ;
  end;
end;


procedure Data (Value: Byte);
var i : Byte;
begin
DlPortWritePortUchar($378 , 255-4);
//sleep (1);
For i := 7 downto 0 do
if (Value And (1 shl i))>0 then
  begin
   DlPortWritePortUchar($37A , 2) ;
   DlPortWritePortUchar($37A , 0) ;
  end
else
  begin
   DlPortWritePortUchar($37A , 3) ;
   DlPortWritePortUchar($37A , 1) ;
  end;

end;


Procedure Command16 (Value: Word; LCD_ExectimeGfx : Cardinal);

Var i : Byte;
    j : integer;
Begin
DlPortWritePortUchar($378 , 255-1);

For i := 7 downto 0 do
if ((Value SHR 8)  AND (1 shl i))>0 then
  Begin
    DlPortWritePortUchar(LCD_Port+2,2);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar(LCD_Port+2,0);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End
else
  Begin
    DlPortWritePortUchar(LCD_Port+2,3);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar(LCD_Port+2,1);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End;

For i := 7 downto 0 do
if (Value AND (1 shl i))>0 then
  Begin
    DlPortWritePortUchar(LCD_Port+2,2);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar(LCD_Port+2,0);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End
else
  Begin
    DlPortWritePortUchar(LCD_Port+2,3);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar(LCD_Port+2,1);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End;

End;





Procedure Data16 (Value: Word; LCD_ExectimeGfx : Cardinal);

Var i : Byte;
    j : integer;
Begin
DlPortWritePortUchar($378 , 255-4);

For i := 7 downto 0 do
if ((Value SHR 8)  AND (1 shl i))>0 then
  Begin
    DlPortWritePortUchar($37A,2);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar($37A,0);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End
else
  Begin
    DlPortWritePortUchar($37A,3);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar($37A,1);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End;

For i := 7 downto 0 do
if (Value AND (1 shl i))>0 then
  Begin
    DlPortWritePortUchar($37A,2);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar($37A,0);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End
else
  Begin
    DlPortWritePortUchar($37A,3);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar($37A,1);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End;

End;




function Bin(x: Integer): string;
const t:array[0..1] of char = ('0','1');
var res:string;
d:0..1;
begin
res:='';
while (x<>0) do
begin
d:=x mod 2 ;
res:=t[d]+res;
x:=x div 2 ;
end;
Bin:=res;

 end;



function BinToDec(const Value: String): Integer;
var i: Integer;
    S: String;
    X: Extended;
begin
  S := Value;
  X := 0;
  S := ReverseString(Value);
  for i := 1 to Length(S) do
    X := X + Power(StrToInt(S[i])*2, i-1);
  Result := Trunc(X);
end;

procedure reset ();
begin
DlPortWritePortUchar($378 , 0+2);//  0
DlPortWritePortUchar($378 , 2);//reset=1
DlPortWritePortUchar($378 , 255); //all=1
DlPortWritePortUchar($378 , 255-2);//reset=1
DlPortWritePortUchar($378 , 255); //all=1



//  LCD_RST_PORT=0;
//  LCD_VDD_PORT=0;
//  LCD_VDD_PORT=1;
//  LCD_DC_PORT = 1;
//  LCD_CE_PORT = 1;
//  LCD_RST_PORT=0; //res=0
//  LCD_RST_PORT=1; //res=1

//DlPortWritePortUchar($378 , 254);//SCE1 rst1   dc0
DlPortWritePortUchar($378 , 252);//rst0   dc0
DlPortWritePortUchar($378 , 254);
end;

procedure TForm1.FormCreate(Sender: TObject);

var
F: TIniFile;
s:string;

begin
  F := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'nastr.ini');
  trackbar3.Position := F.ReadInteger('position', 'kont', 0);
  trackbar7.Position := F.ReadInteger('position', 'black', 0);
  trackbar4.Position := F.ReadInteger('position', 'R', 0);
  trackbar5.Position := F.ReadInteger('position', 'G', 0);
  trackbar6.Position := F.ReadInteger('position', 'B', 0);

  FontDialog1.Font.Name:= F.Readstring('font', 'name', 'Times New Roman');
  FontDialog1.Font.Charset:= F.ReadInteger('font', 'Charset', 0);
  FontDialog1.Font.Color:= F.ReadInteger('font', 'Color', 0);
  FontDialog1.Font.Size:= F.ReadInteger('font', 'Size', 0);


if pos('fsBold',s)<>0 then FontDialog1.font.Style:=FontDialog1.font.Style+[fsBold];
if pos('fsItalic',s)<>0 then FontDialog1.font.Style:=FontDialog1.font.Style+[fsItalic];
if pos('fsUnderline',s)<>0 then FontDialog1.font.Style:=FontDialog1.font.Style+[fsUnderline];
if pos('fsStrikeOut',s)<>0 then FontDialog1.font.Style:=FontDialog1.font.Style+[fsStrikeOut];


if pos('fsBold',s)<>0 then image1.Canvas.font.Style:=image1.Canvas.font.Style+[fsBold];
if pos('fsItalic',s)<>0 then image1.Canvas.font.Style:=image1.Canvas.font.Style+[fsItalic];
if pos('fsUnderline',s)<>0 then image1.Canvas.font.Style:=image1.Canvas.font.Style+[fsUnderline];
if pos('fsStrikeOut',s)<>0 then image1.Canvas.font.Style:=image1.Canvas.font.Style+[fsStrikeOut];

  image1.Canvas.Font.Name:= F.Readstring('font', 'name', 'Times New Roman');
  image1.Canvas.Font.Charset:= F.ReadInteger('font', 'Charset', 0);
  image1.Canvas.Font.Color:= F.ReadInteger('font', 'Color', 0);
  image1.Canvas.Font.Size:= F.ReadInteger('font', 'Size', 0);



  F.Destroy;


image2.Canvas.Brush.Color := RGB(TrackBar4.Position,TrackBar5.Position,TrackBar6.Position);;
image2.Canvas.FillRect(Rect(0, 0, image2.Canvas.ClipRect.Right, image2.Canvas.ClipRect.Bottom));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
reset;

end;



procedure TForm1.Button10Click(Sender: TObject);
var
Bitmap: byte;
begin
Bitmap:=Bitmap+1;

data (Bitmap);
end;

procedure TForm1.Button15Click(Sender: TObject);

Begin

DlPortWritePortUchar($378,24); // Reset Low
Sleep(500);
DlPortWritePortUchar($378,26); // Reset High
Sleep(500);

{------------------------INIT------------------------------}

Command($2c);
Command16($0201, LCD_ExectimeGfx);
Command16($260f, LCD_ExectimeGfx);
Command16($1030, LCD_ExectimeGfx);
Command16($2001, LCD_ExectimeGfx);
Command16($2201, LCD_ExectimeGfx);
Command16($2401, LCD_ExectimeGfx);
Command16($2800, LCD_ExectimeGfx);
//Command16($3040, LCD_ExectimeGfx);
Command16($3201, LCD_ExectimeGfx);
Command16($3482, LCD_ExectimeGfx);
Command16($4000, LCD_ExectimeGfx);
Command16(10921+TrackBar3.Position , LCD_ExectimeGfx);
Command($51);
Sleep(10);
data($0000);
data($0000);
data($0000);
data($0000);
data($0000);
data($0000);
data($0000);
data($0000);


{-----------------------Init END-----------------------------}

end;

procedure TForm1.Button16Click(Sender: TObject);
begin
Command($51); // Display ON
end;

procedure TForm1.Button17Click(Sender: TObject);
begin
Command($50); // Display ON
end;

procedure TForm1.Button21Click(Sender: TObject);
var i,x,y:integer;
begin
i:=0;
x:=0;
y:=0;
Command ($40);
Command ($80);
while i<23232 do begin
i:=i+1;
x:=x+1;
if x=132 then begin
x:=0;
y:=y+1;

 end;
Image1.Canvas.Pixels[x,y] := RGB(0, 0, 0);
Data16(0, LCD_ExectimeGfx);
end;
end;

procedure TForm1.Button22Click(Sender: TObject);
var
x,y:integer;
begin
randomize;
x:=0;
y:=0;
WHILE y<=130 do begin
x:=x+1;
if x>=130 then begin
x:=0;
y:=y+1;

end;
Image1.Canvas.Pixels[x,y] := RGB(Random(255), Random(255), Random(255));

end;
end;

procedure TForm1.Button23Click(Sender: TObject);
var
  c: TColor;
  r,g,b: byte;
  i,x,y,cc:integer;
  rr,gg,bb:string;
begin

Command ($40);
Command ($80);
i:=0;
x:=0;
y:=0;
while i<23232 do begin
//Application.ProcessMessages();
i:=i+1;
x:=x+1;
if x=132 then begin
x:=0;
y:=y+1;

end;
  c:=image1.Canvas.Pixels[x,y];
  r:=GetRValue(c);
  g:=GetgValue(c);
  b:=GetbValue(c);





if r<1 then r:=1;
if g<1 then g:=1;
if b<1 then b:=1;

if r>TrackBar7.Position then r:=(r+255) div 2;
if g>TrackBar7.Position+10 then g:=(g+255) div 2;
if b>TrackBar7.Position then b:=(b+255) div 2;

 rr:=bin(r);
 gg:=bin(g);
 bb:=bin(b);

if length(rr)>5 then delete(rr,6,3);
if length(rr)=4 then rr:='0'+rr;
if length(rr)=3 then rr:='00'+rr;
if length(rr)=2 then rr:='000'+rr;
if length(rr)=1 then rr:='0000'+rr;

if length(gg)>6 then delete(gg,7,2);
if length(gg)=5 then gg:='0'+gg;
if length(gg)=4 then gg:='00'+gg;
if length(gg)=3 then gg:='000'+gg;
if length(gg)=2 then gg:='0000'+gg;
if length(gg)=1 then gg:='00000'+gg;

if length(bb)>5 then delete(bb,6,3);
if length(bb)=4 then bb:='0'+bb;
if length(bb)=3 then bb:='00'+bb;
if length(bb)=2 then bb:='000'+bb;
if length(bb)=1 then bb:='0000'+bb;

cc:=(bintodec(rr+gg+bb));
//cccc:='$'+cc;

data16 (cc, LCD_ExectimeGfx);


end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
if OpenPictureDialog1.Execute then
 begin
  Image1.Picture.LoadFromFile(
   OpenPictureDialog1.FileName);
 end;

end;

procedure TForm1.Button4Click(Sender: TObject);
var
cc,i,x,y,r,g,b:integer;
rr,gg,bb:string;
begin

Command ($40);
Command ($80);
i:=0;
x:=0;
y:=0;
while i<23232 do begin
i:=i+1;
x:=x+1;
if x=132 then begin
x:=0;
y:=y+1;

 end;
Image1.Canvas.Pixels[x,y] := RGB(Trackbar4.Position, Trackbar5.Position, Trackbar6.Position);

r:=Trackbar4.Position;
g:=Trackbar5.Position;
b:=Trackbar6.Position;

if r<1 then r:=1;
if g<1 then g:=1;
if b<1 then b:=1;

if r>TrackBar7.Position then r:=(r+255) div 2;
if g>TrackBar7.Position+10 then g:=(g+255) div 2;
if b>TrackBar7.Position then b:=(b+255) div 2;


rr:=bin(r);
 gg:=bin(g);
 bb:=bin(b);
if length(rr)>5 then delete(rr,6,3);
if length(rr)=4 then rr:='0'+rr;
if length(rr)=3 then rr:='00'+rr;
if length(rr)=2 then rr:='000'+rr;
if length(rr)=1 then rr:='0000'+rr;

if length(gg)>6 then delete(gg,7,2);
if length(gg)=5 then gg:='0'+gg;
if length(gg)=4 then gg:='00'+gg;
if length(gg)=3 then gg:='000'+gg;
if length(gg)=2 then gg:='0000'+gg;
if length(gg)=1 then gg:='00000'+gg;

if length(bb)>5 then delete(bb,6,3);
if length(bb)=4 then bb:='0'+bb;
if length(bb)=3 then bb:='00'+bb;
if length(bb)=2 then bb:='000'+bb;
if length(bb)=1 then bb:='0000'+bb;

cc:=(bintodec(rr+gg+bb));

data16 (cc, LCD_ExectimeGfx);

end;
end;

procedure TForm1.TrackBar4Change(Sender: TObject);
begin


image2.Canvas.Brush.Color := RGB(TrackBar4.Position,TrackBar5.Position,TrackBar6.Position);;
image2.Canvas.FillRect(Rect(0, 0, image2.Canvas.ClipRect.Right, image2.Canvas.ClipRect.Bottom));

end;

procedure TForm1.Button3Click(Sender: TObject);
var
strr:Tfont;
s:string;
begin
if FontDialog1.Execute then begin
  image1.Canvas.Font.Assign(FontDialog1.Font);
  f1:=FontDialog1.Font.Name;
  f2:=FontDialog1.Font.Charset;
  f3:=FontDialog1.Font.Color;
  f4:=FontDialog1.Font.Size;


    if fsBold in FontDialog1.font.Style then S:='fsBold ';
if fsItalic in FontDialog1.font.Style then S:=S+'fsItalic ';
if fsUnderline in FontDialog1.font.Style then S:=S+'fsUnderline ';
if fsStrikeOut in FontDialog1.font.Style then S:=S+'fsStrikeOut';
f5:=s;
  end;
end;

procedure TForm1.TrackBar3Change(Sender: TObject);
begin
Command16(10921+TrackBar3.Position , LCD_ExectimeGfx);// 
end;

procedure TForm1.TrackBar5Change(Sender: TObject);
begin
image2.Canvas.Brush.Color := RGB(TrackBar4.Position,TrackBar5.Position,TrackBar6.Position);;
image2.Canvas.FillRect(Rect(0, 0, image2.Canvas.ClipRect.Right, image2.Canvas.ClipRect.Bottom));
end;

procedure TForm1.TrackBar6Change(Sender: TObject);
begin
image2.Canvas.Brush.Color := RGB(TrackBar4.Position,TrackBar5.Position,TrackBar6.Position);;
image2.Canvas.FillRect(Rect(0, 0, image2.Canvas.ClipRect.Right, image2.Canvas.ClipRect.Bottom));
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
xxx:=x;
yyy:=y;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
image1.Canvas.Brush.Style := bsClear;
image1.Canvas.TextOut(xxx,yyy,edit1.Text);
button23.Click;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
tm:string;
begin
Image1.Picture := nil;
//image1.Canvas.Brush.Style := bsClear;
 image1.Canvas.Font.Assign(FontDialog1.Font);
tm:=TimeToStr(Time);
if length(tm)=4 then delete(tm,5,4) else delete(tm,6,3);
image1.Canvas.TextOut(5,30,tm);
button23.Click;

end;

procedure TForm1.Button5Click(Sender: TObject);
var
tm:string;
begin
//image1.Canvas.Brush.Style := bsClear;

tm:=TimeToStr(Time);
if length(tm)=7 then delete(tm,5,4) else delete(tm,6,3);
Image1.Picture := nil;
image1.Canvas.Font.Assign(FontDialog1.Font);
image1.Canvas.TextOut(5,30,tm);
button23.Click;
Timer1.Enabled:=true;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
Timer1.Enabled:=false;
end;

procedure TForm1.FormDestroy(Sender: TObject);

var
  F: TIniFile;
  s:string;
begin
  f1:=FontDialog1.Font.Name;
  f2:=FontDialog1.Font.Charset;
  f3:=FontDialog1.Font.Color;
  f4:=FontDialog1.Font.Size;


    if fsBold in FontDialog1.font.Style then S:='fsBold ';
if fsItalic in FontDialog1.font.Style then S:=S+'fsItalic ';
if fsUnderline in FontDialog1.font.Style then S:=S+'fsUnderline ';
if fsStrikeOut in FontDialog1.font.Style then S:=S+'fsStrikeOut';
f5:=s;
  F := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'nastr.ini');
  F.WriteInteger('position', 'kont', trackbar3.Position);
  F.WriteInteger('position', 'black', trackbar7.Position);
  F.WriteInteger('position', 'R', trackbar4.Position);
  F.WriteInteger('position', 'G', trackbar5.Position);
  F.WriteInteger('position', 'B', trackbar6.Position);

  f.Writestring('font', 'name', f1);
  f.WriteInteger('font', 'Charset', f2);
  f.WriteInteger('font', 'Color', f3);
  f.WriteInteger('font', 'Size', f4);
  f.Writestring('font', 'Style', f5);



  F.Free;


end;

procedure TForm1.Button7Click(Sender: TObject);
begin
showmessage('Made V@V'+#13+'     Siemens C65'+#13+'Ver 0.9'+#13+'artemvoroncov@yandex.ru');
end;

end.
