unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, StrUtils, Math, jpeg, ExtDlgs,
  XPMan, IniFiles;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button2: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button21: TButton;
    Button22: TButton;
    Button23: TButton;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    Button4: TButton;
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    Edit1: TEdit;
    Image2: TImage;
    FontDialog1: TFontDialog;
    Button3: TButton;
    Button5: TButton;
    Button6: TButton;
    Timer1: TTimer;
    Image3: TImage;
    Timer3: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    Button7: TButton;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure Button22Click(Sender: TObject);
    procedure Button23Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button7Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Light : INTEGER;
  Once : boolean = true; // for BootLogo
  LCD_Width : integer = 130;
  LCD_Height : integer = 130;
  LCD_Port : integer = $378;
  LCD_ExectimeGfx : integer = 0;
  ContrastValue : byte;
  Contrast_ON : boolean;
  Form1: TForm1;
  f2,f3,f4:integer;
  f1,f5:string;
  xxx,yyy,xx1,yy1:integer;
  xer, xer2:integer;
    function DlPortReadPortUchar(Port:longint):byte;stdcall;external 'DLPORTIO.DLL';
    procedure DlPortWritePortUchar(Port:longint;Value:byte);stdcall;external 'DLPORTIO.DLL';
implementation

uses Unit2;

{$R *.dfm}

procedure Command (Value: Byte);
var i : Byte;
begin
DlPortWritePortUchar($378 , 255-1);

For i := 7 downto 0 do
if (Value And (1 shl i))>0 then
  begin
   DlPortWritePortUchar($37A , 2) ;
   DlPortWritePortUchar($37A , 0) ;
  end
else
  begin
   DlPortWritePortUchar($37A , 3) ;
   DlPortWritePortUchar($37A , 1) ;
  end;
end;


procedure Data (Value: Byte);
var i : Byte;
begin
DlPortWritePortUchar($378 , 255-4);
//sleep (1);
For i := 7 downto 0 do
if (Value And (1 shl i))>0 then
  begin
   DlPortWritePortUchar($37A , 2) ;
   DlPortWritePortUchar($37A , 0) ;
  end
else
  begin
   DlPortWritePortUchar($37A , 3) ;
   DlPortWritePortUchar($37A , 1) ;
  end;

end;


Procedure Command16 (Value: Word; LCD_ExectimeGfx : Cardinal);

Var i : Byte;
    j : integer;
Begin
DlPortWritePortUchar($378 , 255-1);

For i := 7 downto 0 do
if ((Value SHR 8)  AND (1 shl i))>0 then
  Begin
    DlPortWritePortUchar(LCD_Port+2,2);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar(LCD_Port+2,0);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End
else
  Begin
    DlPortWritePortUchar(LCD_Port+2,3);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar(LCD_Port+2,1);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End;

For i := 7 downto 0 do
if (Value AND (1 shl i))>0 then
  Begin
    DlPortWritePortUchar(LCD_Port+2,2);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar(LCD_Port+2,0);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End
else
  Begin
    DlPortWritePortUchar(LCD_Port+2,3);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar(LCD_Port+2,1);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End;

End;





Procedure Data16 (Value: Word; LCD_ExectimeGfx : Cardinal);

Var i : Byte;
    j : integer;
Begin
DlPortWritePortUchar($378 , 255-4);

For i := 7 downto 0 do
if ((Value SHR 8)  AND (1 shl i))>0 then
  Begin
    DlPortWritePortUchar($37A,2);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar($37A,0);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End
else
  Begin
    DlPortWritePortUchar($37A,3);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar($37A,1);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End;

For i := 7 downto 0 do
if (Value AND (1 shl i))>0 then
  Begin
    DlPortWritePortUchar($37A,2);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar($37A,0);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End
else
  Begin
    DlPortWritePortUchar($37A,3);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
    DlPortWritePortUchar($37A,1);
      for j := 1 to LCD_ExectimeGfx do  DLPortReadPortUChar($220);
  End;

End;




function Bin(x: Integer): string;
const t:array[0..1] of char = ('0','1');
var res:string;
d:0..1;
begin
res:='';
while (x<>0) do
begin
d:=x mod 2 ;
res:=t[d]+res;
x:=x div 2 ;
end;
Bin:=res;

 end;



function BinToDec(const Value: String): Integer;
var i: Integer;
    S: String;
    X: Extended;
begin
  S := Value;
  X := 0;
  S := ReverseString(Value);
  for i := 1 to Length(S) do
    X := X + Power(StrToInt(S[i])*2, i-1);
  Result := Trunc(X);
end;





procedure TForm1.FormCreate(Sender: TObject);

var
F: TIniFile;
s:string;

begin
  F := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'nastr.ini');


  trackbar4.Position := F.ReadInteger('position', 'R', 0);
  trackbar5.Position := F.ReadInteger('position', 'G', 0);
  trackbar6.Position := F.ReadInteger('position', 'B', 0);

  FontDialog1.Font.Name:= F.Readstring('font', 'name', 'Times New Roman');
  FontDialog1.Font.Charset:= F.ReadInteger('font', 'Charset', 0);
  FontDialog1.Font.Color:= F.ReadInteger('font', 'Color', 0);
  FontDialog1.Font.Size:= F.ReadInteger('font', 'Size', 0);


if pos('fsBold',s)<>0 then FontDialog1.font.Style:=FontDialog1.font.Style+[fsBold];
if pos('fsItalic',s)<>0 then FontDialog1.font.Style:=FontDialog1.font.Style+[fsItalic];
if pos('fsUnderline',s)<>0 then FontDialog1.font.Style:=FontDialog1.font.Style+[fsUnderline];
if pos('fsStrikeOut',s)<>0 then FontDialog1.font.Style:=FontDialog1.font.Style+[fsStrikeOut];


if pos('fsBold',s)<>0 then image1.Canvas.font.Style:=image1.Canvas.font.Style+[fsBold];
if pos('fsItalic',s)<>0 then image1.Canvas.font.Style:=image1.Canvas.font.Style+[fsItalic];
if pos('fsUnderline',s)<>0 then image1.Canvas.font.Style:=image1.Canvas.font.Style+[fsUnderline];
if pos('fsStrikeOut',s)<>0 then image1.Canvas.font.Style:=image1.Canvas.font.Style+[fsStrikeOut];

  image1.Canvas.Font.Name:= F.Readstring('font', 'name', 'Times New Roman');
  image1.Canvas.Font.Charset:= F.ReadInteger('font', 'Charset', 0);
  image1.Canvas.Font.Color:= F.ReadInteger('font', 'Color', 0);
  image1.Canvas.Font.Size:= F.ReadInteger('font', 'Size', 0);

  xx1:= F.ReadInteger('perem', 'xx1', 0);
  yy1:= F.ReadInteger('perem', 'yy1', 0);
  combobox1.ItemIndex:=F.ReadInteger('perem', 'box1', 0);
  label2.Caption:='  '+inttostr(xx1)+' x '+inttostr(yy1);


  F.Destroy;


image2.Canvas.Brush.Color := RGB(TrackBar4.Position,TrackBar5.Position,TrackBar6.Position);
image2.Canvas.FillRect(Rect(0, 0, image2.Canvas.ClipRect.Right, image2.Canvas.ClipRect.Bottom));
image3.Canvas.Brush.Color := RGB(TrackBar4.Position,TrackBar5.Position,TrackBar6.Position);
image3.Canvas.FillRect(Rect(0, 0, image3.Canvas.ClipRect.Right, image3.Canvas.ClipRect.Bottom));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Command($01);

end;



procedure TForm1.Button15Click(Sender: TObject);

Begin
timer1.Enabled:=false;
timer3.Enabled:=false;
DlPortWritePortUchar($378, 0);
Sleep(500);
DlPortWritePortUchar($378,24); // Reset Low
Sleep(500);
DlPortWritePortUchar($378,26); // Reset High
Sleep(500);
{------------------------INIT------------------------------}

Command($01);
Sleep(20);
Command($36);
Command($80);
Command($11);
Sleep(20);
Command($3a);
Command($55);
Sleep(20);
Command($29);


{-----------------------Init END-----------------------------}

end;

procedure TForm1.Button16Click(Sender: TObject);
begin
Command($29); // Display ON
end;

procedure TForm1.Button17Click(Sender: TObject);
begin
Command($28); // Display ON
end;

procedure TForm1.Button21Click(Sender: TObject);
var i,x,y:integer;
begin
i:=0;
x:=0;
y:=0;
while i<23232 do begin
i:=i+1;
x:=x+1;
if x=132 then begin
x:=0;
y:=y+1;

 end;
Image1.Canvas.Pixels[x,y] := RGB(255, 255, 255);

end;
button23.Click;
end;




procedure TForm1.Button22Click(Sender: TObject);
var
x,y:integer;
begin
randomize;
x:=0;
y:=0;
WHILE y<=176 do begin
x:=x+1;
if x>=132 then begin
x:=0;
y:=y+1;

end;
Image1.Canvas.Pixels[x,y] := RGB(Random(255), Random(255), Random(255));

end;
end;

procedure TForm1.Button23Click(Sender: TObject);
var
  c: TColor;
  r,g,b: byte;
  i,x,y:integer;

begin
i:=0;
x:=0;
y:=0;
if combobox1.ItemIndex<>0 then begin

while i<2640 do begin
image1.Canvas.Pixels[x,y]:=image3.Canvas.Pixels[x,y];
i:=i+1;
x:=x+1;



if x=132 then begin
x:=0;
y:=y+1;
end;


end;
end;
timer3.Enabled:=false;
Command($2a);
data (0);
data (132);
Command($2b);
data (0);
data (175);
Command($2c);
i:=0;
x:=0;
y:=0;
while i<23232 do begin
//Application.ProcessMessages();
i:=i+1;
x:=x+1;
  c:=image1.Canvas.Pixels[x,y];
  r:=GetRValue(c);
  g:=GetgValue(c);
  b:=GetbValue(c);
 data(r div 4);
 data(g div 4);
 data(b div 4);

if x=132 then begin
x:=0;
y:=y+1;

end;

end;
if combobox1.ItemIndex<>0 then timer3.Enabled:=true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
if OpenPictureDialog1.Execute then
 begin
  Image1.Picture.LoadFromFile(
   OpenPictureDialog1.FileName);
 end;

end;

procedure TForm1.Button4Click(Sender: TObject);
var i,x,y:integer;
begin
i:=0;
x:=0;
y:=0;
while i<23232 do begin
i:=i+1;
x:=x+1;
Image1.Canvas.Pixels[x,y] := RGB(trackbar4.Position, trackbar5.Position, trackbar6.Position);
if x=132 then begin
x:=0;
y:=y+1;

 end;


end;
button23.Click;
end;




procedure TForm1.TrackBar4Change(Sender: TObject);
begin


image2.Canvas.Brush.Color := RGB(TrackBar4.Position,TrackBar5.Position,TrackBar6.Position);;
image2.Canvas.FillRect(Rect(0, 0, image2.Canvas.ClipRect.Right, image2.Canvas.ClipRect.Bottom));

end;

procedure TForm1.Button3Click(Sender: TObject);
var

s:string;
begin
if FontDialog1.Execute then begin
  image1.Canvas.Font.Assign(FontDialog1.Font);
  f1:=FontDialog1.Font.Name;
  f2:=FontDialog1.Font.Charset;
  f3:=FontDialog1.Font.Color;
  f4:=FontDialog1.Font.Size;


    if fsBold in FontDialog1.font.Style then S:='fsBold ';
if fsItalic in FontDialog1.font.Style then S:='fsItalic ';
if fsUnderline in FontDialog1.font.Style then S:='fsUnderline ';
if fsStrikeOut in FontDialog1.font.Style then S:='fsStrikeOut';
f5:=s;
  end;
end;

procedure TForm1.TrackBar5Change(Sender: TObject);
begin
image2.Canvas.Brush.Color := RGB(TrackBar4.Position,TrackBar5.Position,TrackBar6.Position);;
image2.Canvas.FillRect(Rect(0, 0, image2.Canvas.ClipRect.Right, image2.Canvas.ClipRect.Bottom));
end;

procedure TForm1.TrackBar6Change(Sender: TObject);
begin
image2.Canvas.Brush.Color := RGB(TrackBar4.Position,TrackBar5.Position,TrackBar6.Position);;
image2.Canvas.FillRect(Rect(0, 0, image2.Canvas.ClipRect.Right, image2.Canvas.ClipRect.Bottom));
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
xxx:=x;
yyy:=y;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
if edit1.Text<>'' then begin
image1.Canvas.Brush.Style := bsClear;
image1.Canvas.TextOut(xxx,yyy,edit1.Text);
button23.Click;
end;

if timer1.Enabled=true then if edit1.Text='' then begin
xx1:=xxx;
yy1:=yyy;
label2.Caption:='  '+inttostr(xx1)+' x '+inttostr(yy1);
button5.Click;
end;
end;
procedure TForm1.Timer1Timer(Sender: TObject);
var
tm:string;
i,x,y:integer;
begin
image1.Canvas.Brush.Style := bsClear;

tm:=TimeToStr(Time);
if length(tm)=7 then delete(tm,5,4) else delete(tm,6,3);


i:=0;
x:=0;
y:=0;
while i<23232 do begin
i:=i+1;
x:=x+1;
if x=132 then begin
x:=0;
y:=y+1;

 end;
Image1.Canvas.Pixels[x,y]:= RGB(trackbar4.Position, trackbar5.Position, trackbar6.Position);
 end;
 image1.Canvas.Brush.Color := RGB(trackbar4.Position, trackbar5.Position, trackbar6.Position);

image1.Canvas.Font.Assign(FontDialog1.Font);
image1.Canvas.TextOut(xx1,yy1,tm);
button23.Click;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
tm:string;
i,x,y:integer;
begin
image1.Canvas.Brush.Style := bsClear;

tm:=TimeToStr(Time);
if length(tm)=7 then delete(tm,5,4) else delete(tm,6,3);


i:=0;
x:=0;
y:=0;
while i<23408 do begin
Image1.Canvas.Pixels[x,y]:= RGB(trackbar4.Position, trackbar5.Position, trackbar6.Position);
i:=i+1;
x:=x+1;
if x=133 then begin
x:=0;
y:=y+1;

 end;

 end;
 image1.Canvas.Brush.Color := RGB(trackbar4.Position, trackbar5.Position, trackbar6.Position);

image1.Canvas.Font.Assign(FontDialog1.Font);
image1.Canvas.TextOut(xx1,yy1,tm);
button23.Click;
Timer1.Enabled:=true;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
Timer1.Enabled:=false;
end;

procedure TForm1.FormDestroy(Sender: TObject);

var
  F: TIniFile;
  s:string;
begin
  f1:=FontDialog1.Font.Name;
  f2:=FontDialog1.Font.Charset;
  f3:=FontDialog1.Font.Color;
  f4:=FontDialog1.Font.Size;


if fsBold in FontDialog1.font.Style then S:='fsBold ';
if fsItalic in FontDialog1.font.Style then S:='fsItalic ';
if fsUnderline in FontDialog1.font.Style then S:='fsUnderline ';
if fsStrikeOut in FontDialog1.font.Style then S:='fsStrikeOut';
f5:=s;

  F := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'nastr.ini');


  F.WriteInteger('position', 'R', trackbar4.Position);
  F.WriteInteger('position', 'G', trackbar5.Position);
  F.WriteInteger('position', 'B', trackbar6.Position);

  f.Writestring('font', 'name', f1);
  f.WriteInteger('font', 'Charset', f2);
  f.WriteInteger('font', 'Color', f3);
  f.WriteInteger('font', 'Size', f4);
  f.Writestring('font', 'Style', f5);

  f.WriteInteger('perem', 'xx1', xx1);
  f.WriteInteger('perem', 'yy1', yy1);
  f.WriteInteger('perem', 'box1', combobox1.ItemIndex);




  F.Free;


end;

procedure TForm1.Timer3Timer(Sender: TObject);
var
  c: TColor;
  r,g,b: byte;
  i,x,y,rr,xx2,yy2:integer;
  tm:string;

begin

randomize;
Image3.Picture := nil;

image3.Canvas.Brush.Color := RGB(trackbar4.Position, trackbar5.Position, trackbar6.Position);
Image3.Canvas.Rectangle(1,0,134,20);


if combobox1.ItemIndex=0 then begin
image3.Canvas.Brush.Color := RGB(trackbar4.Position, trackbar5.Position, trackbar6.Position);
Image3.Canvas.Rectangle(1,0,134,20);

end;


if combobox1.ItemIndex=1 then begin
image3.Canvas.Brush.Color := FontDialog1.Font.Color;
Image3.Canvas.Rectangle(12,random(19),22,20);
Image3.Canvas.Rectangle(26,random(19),36,20);
Image3.Canvas.Rectangle(40,random(19),50,20);
Image3.Canvas.Rectangle(54,random(19),64,20);
Image3.Canvas.Rectangle(68,random(19),78,20);
Image3.Canvas.Rectangle(82,random(19),92,20);
Image3.Canvas.Rectangle(96,random(19),106,20);
Image3.Canvas.Rectangle(110,random(19),120,20);
end;


if combobox1.ItemIndex=2 then begin
image3.Canvas.Brush.Color := FontDialog1.Font.Color;
 rr:=random(8)+4;
 xx2:=random(125)+5;
 yy2:=random(15)+4;
Image3.Canvas.Ellipse (xx2+rr,yy2+rr,xx2-rr,yy2-rr);
 rr:=random(8)+4;
 xx2:=random(125)+5;
 yy2:=random(15)+4;
Image3.Canvas.Ellipse (xx2+rr,yy2+rr,xx2-rr,yy2-rr);
 rr:=random(8)+4;
 xx2:=random(125)+5;
 yy2:=random(15)+4;
Image3.Canvas.Ellipse (xx2+rr,yy2+rr,xx2-rr,yy2-rr);
 rr:=random(8)+4;
 xx2:=random(125)+5;
 yy2:=random(15)+4;
Image3.Canvas.Ellipse (xx2+rr,yy2+rr,xx2-rr,yy2-rr);
 rr:=random(8)+4;
 xx2:=random(125)+5;
 yy2:=random(15)+4;
Image3.Canvas.Ellipse (xx2+rr,yy2+rr,xx2-rr,yy2-rr);
 rr:=random(8)+4;
 xx2:=random(125)+5;
 yy2:=random(15)+4;
Image3.Canvas.Ellipse (xx2+rr,yy2+rr,xx2-rr,yy2-rr);
 rr:=random(8)+4;
 xx2:=random(125)+5;
 yy2:=random(15)+4;
Image3.Canvas.Ellipse (xx2+rr,yy2+rr,xx2-rr,yy2-rr);
 rr:=random(8)+4;
 xx2:=random(125)+5;
 yy2:=random(15)+4;
Image3.Canvas.Ellipse (xx2+rr,yy2+rr,xx2-rr,yy2-rr);

end;

if combobox1.ItemIndex=3 then begin
image3.Canvas.Font.Color := FontDialog1.Font.Color;
image3.Canvas.Font.Size  := 11;

tm:=dateToStr(date);
image3.Canvas.TextOut(35,1,tm);

 end;

if combobox1.ItemIndex=4 then begin
image3.Canvas.Pen.Color := FontDialog1.Font.Color;
image3.Canvas.MoveTo(random(130),random(19));
image3.Canvas.lineto(random(130),random(19));
image3.Canvas.lineto(random(130),random(19));
image3.Canvas.lineto(random(130),random(19));
image3.Canvas.lineto(random(130),random(19));
image3.Canvas.lineto(random(130),random(19));
image3.Canvas.lineto(random(130),random(19));
image3.Canvas.lineto(random(130),random(19));

end;


 if combobox1.ItemIndex=5 then begin
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
image3.Canvas.Pixels[random(130),random(19)] := FontDialog1.Font.Color;
end;


Command($2a);
data (0);
data (131);
Command($2b);
data (0);
data (20);
Command($2c);



i:=0;
x:=0;
y:=0;


while i<2640 do begin
image1.Canvas.Pixels[x,y]:=image3.Canvas.Pixels[x,y];
i:=i+1;
x:=x+1;



if x=132 then begin
x:=0;
y:=y+1;
end;


end;




i:=0;
x:=0;
y:=0;
while i<2640 do begin

Application.ProcessMessages();

i:=i+1;
x:=x+1;
c:=image3.Canvas.Pixels[x,y];
  r:=GetRValue(c);
  g:=GetgValue(c);
  b:=GetbValue(c);


 data(r div 4);
 data(g div 4);
 data(b div 4);
if x=132 then begin
x:=0;
y:=y+1;

end;

end;
if combobox1.ItemIndex=0 then timer3.Enabled:=false;

end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
timer3.Enabled:=false;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
timer3.Enabled:=true;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
timer3.Enabled:=true ;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
showmessage('Made V@V'+#13+'     Siemens C75'+#13+'Ver 1.0'+#13+'artemvoroncov@yandex.ru');
end;

end.
