unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button3: TButton;
    Button1: TButton;
    Image1: TImage;
    Button5: TButton;
    Button6: TButton;
    Timer1: TTimer;
    Button2: TButton;
    Button4: TButton;
    Button7: TButton;
    Button8: TButton;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure TrackBar1Change(Sender: TObject);
    procedure Button8Click(Sender: TObject);

    procedure Button7Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
    function DlPortReadPortUchar(Port:longint):byte;stdcall;external 'DLPORTIO.DLL';
    procedure DlPortWritePortUchar(Port:longint;Value:byte);stdcall;external 'DLPORTIO.DLL';
implementation

{$R *.dfm}
//-----------------------------------------------
procedure Command (Value: Byte);
var i : Byte;
begin
DlPortWritePortUchar($378 , 255-1);

For i := 7 downto 0 do
if (Value And (1 shl i))>0 then
  begin
   DlPortWritePortUchar($37A , 2) ;
   DlPortWritePortUchar($37A , 0) ;
  end
else
  begin
   DlPortWritePortUchar($37A , 3) ;
   DlPortWritePortUchar($37A , 1) ;
  end;
end;
//-----------------------------------------------
procedure Data (Value: Byte);
var i : Byte;
begin
DlPortWritePortUchar($378 , 255-4);
//sleep (1);
For i := 7 downto 0 do
if (Value And (1 shl i))>0 then
  begin
   DlPortWritePortUchar($37A , 2) ;
   DlPortWritePortUchar($37A , 0) ;
  end
else
  begin
   DlPortWritePortUchar($37A , 3) ;
   DlPortWritePortUchar($37A , 1) ;
  end;

end;
//-----------------------------------------------
procedure reset ();
begin
//DlPortWritePortUchar($378 , 0+2);//  0
//DlPortWritePortUchar($378 , 2);//reset=1
//DlPortWritePortUchar($378 , 255); //all=1
//DlPortWritePortUchar($378 , 255-2);//reset=1
//DlPortWritePortUchar($378 , 255); //all=1



//  LCD_RST_PORT=0;
//  LCD_VDD_PORT=0;
//  LCD_VDD_PORT=1;
//  LCD_DC_PORT = 1;
//  LCD_CE_PORT = 1;
//  LCD_RST_PORT=0; //res=0
//  LCD_RST_PORT=1; //res=1

//DlPortWritePortUchar($378 , 254);//SCE1 rst1   dc0
DlPortWritePortUchar($378 , 252);//rst0   dc0
DlPortWritePortUchar($378 , 254);
end;


//-----------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
end;
//-----------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
DlPortWritePortUchar($378, 0);
end;
//-----------------------------------------------
procedure TForm1.Button2Click(Sender: TObject);
begin
reset;
end;
//-----------------------------------------------
procedure TForm1.Button3Click(Sender: TObject);
begin
timer1.Enabled:=false;
reset;
Command ($21) ; // PowerON, ExtCommandSet
Command ($8+0)  ;// Internal HV-gen x3 +(0-3)  9
Command ($80 + $33) ;// Set Vop
Command ($10+0) ;// Bias n=2  //15   +(0-7)     16
Command ($4+0) ;// Temperature coeff 2   +(0-3)  6
Command ($20) ;// StandartCommandSet
Command ($C)  ;// normal mode, display non-inverted

end;

procedure TForm1.Button4Click(Sender: TObject);
var i:integer;
begin
Command ($40);
Command ($80);
for I := 0 to 917 do data($aa);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
i : integer ;
begin
timer1.Enabled:=false;
Command ($40);
Command ($80);
For i := 0 To 917 do data (0) ;
end;

//-----------------------------------------------
procedure TForm1.Button5Click(Sender: TObject);
var
  j ,i , z , Bitmap: byte;
begin
j:=0;
Command ($40);
Command ($80);
while j<64 do
 begin
   for i := 0 to 101 do
     begin
      Bitmap := 0;
      for z:=0 to 7 do
       if (image1.Canvas.Pixels[i, z+j])=0 then Bitmap :=Bitmap + 128 shr z ;
       data (Bitmap);
     end;
  j:=j+8 ;
  end;
  data (0) ;
end;
//-----------------------------------------------

procedure TForm1.Timer1Timer(Sender: TObject);
var
  j ,i , z , Bitmap: byte;
begin
image1.Canvas.Font.Size:=18;
image1.Canvas.TextOut(4,20,TimeToStr(Time));
j:=0;
Command ($40);
Command ($80);
while j<64 do
 begin
   for i := 0 to 101 do
     begin
      Bitmap := 0;
      for z:=0 to 7 do
       if (image1.Canvas.Pixels[i, z+j])=0 then Bitmap :=Bitmap + 128 shr z ;
       data (Bitmap);
     end;
  j:=j+8 ;
  end;

end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
label1.Caption  := 'HV-gen ' + inttostr(TrackBar1.Position ) ;
label2.Caption  := 'Vop ' + inttostr(TrackBar2.Position ) ;
label3.Caption  := 'Bias ' + inttostr(TrackBar3.Position ) ;
label4.Caption  := 'Temp ' + inttostr(TrackBar4.Position ) ;

Command ($21) ; // PowerON, ExtCommandSet
Command (TrackBar1.Position)  ;// Internal HV-gen x3 +(0-3)  9
Command (TrackBar2.Position) ;// Set Vop
Command (TrackBar3.Position) ;// Bias n=2  //15   +(0-7)     16
Command (TrackBar4.Position) ;// Temperature coeff 2   +(0-3)  6
Command ($20) ;// StandartCommandSet
Command ($C)  ;// normal mode, display non-inverted


end;

procedure TForm1.Button6Click(Sender: TObject);
begin
timer1.Enabled:=true;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
DlPortWritePortUchar($378 , 0);//  0
end;

procedure TForm1.Button8Click(Sender: TObject);
var
i : integer ;
begin


For i := 0 To 101 do data (255-i) ;
end;

end.
